package TiVo::Slice::Field::Index;

use strict;
use base qw(TiVo::Slice::Field);
use TiVo::Slice::Number;

our $VERSION =
    (split / /, q$Id: Index.pm,v 1.1 2001/12/02 11:00:19 grant Exp $)[2];

sub new {
    my $class = shift;
    my $value = shift;
    unless ( (ref($value) eq "ARRAY") and (@$value == 3) ) {
        die "argument must be a reference to a three element array " .
            "(objtype, attr, index)";
    }
    my ($objtype, $attr, $index) = @$value;
    my $self = 
        $class->SUPER::new(
                           TiVo::Slice::Number->new($objtype)->tivonumber .
                           TiVo::Slice::Number->new($attr)->tivonumber .
                           TiVo::Slice::Number->new($index)->tivonumber
                          );
    return $self;
}

1;
