package TiVo::Web::Parser;

use strict;
use TiVo::Config;

our $VERSION =
    (split / /, q$Id: Parser.pm,v 1.3 2001/12/03 09:36:26 grant Exp $)[2];

# this bit is a little weird
# look in the config for which web guide to use (eg, zap2it)
# return an instance of the webguide's parser, which is based on this class
sub new {
    my $class = shift;
    if ($class eq "TiVo::Web::Parser") {
        # act as a wrapper
        my $conf = TiVo::Config->new;
        my $pkg = 'TiVo::' . $conf->webguide . '::Parser';
        eval "require $pkg" or die $@;
        return $pkg->new(@_);
    }
    else {
        # normal new
        my $self = {};
        bless $self, $class;
        return $self;
    }
}

sub METHOD::ABSTRACT {
    my $self = shift;
    my $object_class = ref($self);
    my ($file, $line, $method) = (caller(1))[1..3];
    my $loc = "at $file, line $line\n";
    die "someone used an (abstract) TiVo::Web::Parser object $loc"
        if $object_class eq 'TiVo::Web::Parser';
    die "call to abstract method ${method} $loc";
}

# should return a list of TiVo::Show objects
sub parse_page { ABSTRACT METHOD @_ }

1;
